local debug = false
--[===[@alpha@
debug = true
--@end-alpha@]===]
local L = LibStub("AceLocale-3.0"):GetLocale("AchScreenshotter2", not debug)

local mod = AchScreenshotter2
local addonname = "AchScreenShotter2"
-- @usage prueft ob die guid ein boss war und ob er auf der blacklist steht
local function checkboss(GUID)
  local id = tonumber(GUID:sub(7, 10), 16)
  local blacklist = mod.gsv.blacklist
  if ((blacklist[id] == nil) or (not blacklist[id].enable)) then  -- damit keine screens unnoetig im kampf ausgeloest werden
    local whitelist = mod.gsv.whitelist
    if (((whitelist[id] ~= nil) and whitelist[id].enable) or LibStub("LibBossIDs-1.0").BossIDs[id]) then
      mod:take_screenshot("boss", mod.sv.boss.hideui, mod.sv.delay)
    end
  end
end

-- The 4.1 patch will add a new parameter, hideCaster, effectively moving all other parameters beginning with sourceGUID one place to the right.
-- The 4.2 patch added two new parameters, sourceRaidFlags and destRaidFlags 
-- These two parameters were added at the end of the source and destination "subsections" moving all destination parameters one place to the right, and all other parameters two places to the right. Addons that haven't been updated for 4.2 may not function correctly as a result.

-- 4.1
-- 1st Param	2nd Param	3rd Param	4th Param	5th Param	6th Param	7th Param	8th Param	9th Param
-- timestamp	event	hideCaster	sourceGUID	sourceName	sourceFlags	destGUID	destName	destFlags
-- 4.2
-- 1st Param	2nd Param	3rd Param	4th Param	5th Param	6th Param	7th Param	8th Param	9th Param	10th Param	11th Param
-- timestamp	event	hideCaster	sourceGUID	sourceName	sourceFlags	sourceRaidFlags	destGUID	destName	destFlags	destRaidFlags
-- @usage diese funktion prueft ob der getoetete mob ein boss war oder nicht
-- @usage nur 5 normal bis jetzt getestet aber die anderen muessten auch funktionieren
function AchScreenshotter2:boss_function(_, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9)
  local event = arg2
  local destguid = nil
  if (select(4,GetBuildInfo()) < 40100) then -- 4.0
      destguid = arg6
  end
  if (select(4,GetBuildInfo()) >= 40100) and (select(4,GetBuildInfo()) < 40200) then -- ptr 4.1
      destguid = arg7
  end
  if (select(4,GetBuildInfo()) >= 40200) then -- ptr 4.2
      destguid = arg8
  end

  if event == "UNIT_DIED" then
    local _, instanceType = IsInInstance()

    if ((instanceType == "none") and mod.sv.boss.world) then -- in der aussenwelt
      checkboss(destguid)
    elseif ((instanceType == "party") and (mod.sv.boss.five or mod.sv.boss.fivehero)) then -- in einer 5 man instanz
      local difficulty = GetInstanceDifficulty()

      if ((difficulty == 1) and (mod.sv.boss.five)) then -- normale
        checkboss(destguid)
      elseif ((difficulty == 2) and (mod.sv.boss.fivehero)) then -- hero
        checkboss(destguid)
      end
    elseif ((instanceType == "raid") and (mod.sv.boss.ten or mod.sv.boss.tenhero or mod.sv.boss.twentyfive or mod.sv.boss.twentyfivehero)) then -- raid
      local difficulty = GetInstanceDifficulty()

      if ((difficulty == 1) and (mod.sv.boss.ten)) then -- 10 normal
        checkboss(destguid)
      elseif ((difficulty == 2) and (mod.sv.boss.twentyfive)) then -- 25 normal
        checkboss(destguid)
      elseif ((difficulty == 3) and (mod.sv.boss.tenhero)) then -- 10 hero
        checkboss(destguid)
      elseif ((difficulty == 4) and (mod.sv.boss.twentyfivehero)) then -- 25 hero
        checkboss(destguid)
      end
    end
  end
end

function AchScreenshotter2:getbossoptions()
  local version = GetAddOnMetadata(addonname, "X-Curse-Packaged-Version") or ""
  local bossoptions = {
        name = L["Boss"].." "..version,
        type = "group",
        --desc = L["boss options"],
        childGroups	= "tab",
        args = {
          main = mod:getmainbossoptions(),
          blacklist = mod:getblacklistoptions(),
          whitelist = mod:getwhitelistoptions(),
        }
    }
return bossoptions
end

function AchScreenshotter2:getmainbossoptions()
  local bossmainoptions = {
        name = L["boss options"],
        type = "group",
        desc = L["boss options"],
        order = 1,
        args = {
          boss = {
            name = L["boss enable"],
            type = "toggle",
            order = 61,
            desc = L["boss enable desc"],
            get = function() return mod.sv.boss.enable end,
            set = function(_, val)
              mod.sv.boss.enable = val
              mod:RefreshConfig()
              end,
            },
          hideui ={
            name = L["hideui enable"],
            type = "toggle",
            order = 62,
            desc = L["hideui desc"],
            get = function() return mod.sv.bg.hideui end,
            set = function(_, val)
              mod.sv.bg.hideui = val
              end,
            },
          header = {
            name = L["misc"],
            type = "header",
            order = 63,
          },
          boss_world = {
            name = L["world boss enable"],
            type = "toggle",
            order = 64,
            desc = L["world boss enable desc"],
            get = function() return mod.sv.boss.world end,
            set = function(_, val)
              mod.sv.boss.world = val
              end,
            },
          n1 = {
            type = "description",
            name = "",
            order = 70,
            },
          boss_five = {
            name = L["five men boss enable"],
            type = "toggle",
            order = 71,
            desc = L["five men boss enable desc"],
            get = function() return mod.sv.boss.five end,
            set = function(_, val)
              mod.sv.boss.five = val
              end,
            },
          boss_five_hero = {
            name = L["five men hero boss enable"],
            type = "toggle",
            order = 72,
            desc = L["five men hero boss enable desc"],
            get = function() return mod.sv.boss.fivehero end,
            set = function(_, val)
              mod.sv.boss.fivehero = val
              end,
            },
          n2 = {
            type = "description",
            name = "",
            order = 80,
            },
          boss_ten = {
            name = L["ten men boss enable"],
            type = "toggle",
            order = 81,
            desc = L["ten men boss enable desc"],
            get = function() return mod.sv.boss.ten end,
            set = function(_, val)
              mod.sv.boss.ten = val
              end,
            },
          boss_ten_hero = {
            name = L["ten men hero boss enable"],
            type = "toggle",
            order = 82,
            desc = L["ten men hero boss enable desc"],
            get = function() return mod.sv.boss.tenhero end,
            set = function(_, val)
              mod.sv.boss.tenhero = val
              end,
            },
          n3 = {
            type = "description",
            name = "",
            order = 90,
            },
          boss_twentyfive = {
            name = L["twentyfive men boss enable"],
            type = "toggle",
            order = 91,
            desc = L["twentyfive men boss enable desc"],
            get = function() return mod.sv.boss.twentyfive end,
            set = function(_, val)
              mod.sv.boss.twentyfive = val
              end,
            },
          boss_twentyfive_hero = {
            name = L["twentyfive men hero boss enable"],
            type = "toggle",
            order = 92,
            desc = L["twentyfive men hero boss enable desc"],
            get = function() return mod.sv.boss.twentyfivehero end,
            set = function(_, val)
              mod.sv.boss.twentyfivehero = val
              end,
            },
        }
    }
return bossmainoptions
end



do
  local newid, new_name, edit_id, edit_name, edit_enable, edit_category, edit_category_locale, edit_select

  local BZ = LibStub("LibBabble-Zone-3.0"):GetUnstrictLookupTable()
  local BB = LibStub("LibBabble-Boss-3.0"):GetUnstrictLookupTable()

  function AchScreenshotter2:getblacklistoptions()
  local blacklistoptions = {
          name = L["blacklist"],
          type = "group",
          desc = L["blacklist desc"],
          order = 2,
          childGroups	= "tab",
          args = {
            new = {
              name = L["new"],
              type = "group",
              desc = L["new desc"],
              order = 1,
              args = {
                mobid = {
                  name = L["mob id"],
                  type = "input",
                  order = 1,
                  get = function()
                    local out
                    if (new_id ~= nil) then
                      out = tostring(new_id)
                    else 
                      out = 0
                    end
                    return out 
                  end,
                  set = function(_, val)
                    new_id = tonumber(val)
                  end,
                  multiline = false,
                  usage = "<"..L["the mob id is a number"]..">",
                  },
                mobname = {
                  name = L["mob name"],
                  type = "input",
                  order = 2,
                  get = function() return new_name or "" end,
                  set = function(_, val)
                    new_name = val
                  end,
                  multiline = false,
                  usage = "<"..L["simply the name"]..">",
                  },
                ok = {
                  name = L["ok"],
                  type = "execute",
                  order = 3,
                  desc = L["ok desc"],
                  func = function()
                    mod.gsv.blacklist[new_id] = {
                      enable = true,
                      name = new_name,
                      category = "own",
                    }
                    new_id = nil
                    new_name = nil
                  end,
                  disabled = function()
                    return not (new_id and new_name)
                  end
                  },
                },
              },
            edit = {
              name = L["edit"],
              type = "group",
              desc = L["edit desc"],
              order = 2,
              args = {
                select_category = { -- erstellt eine table mit allen inis
                  name = L["category"],
                  type = "select",
                  order = 1,
                  get = function() return edit_category or "" end,
                  set = function(_, val)
                    edit_category = val
                    if val == "own" then -- die ini eigene ist das selbst eingetragene. bz kann das net kennen
                      edit_category_locale = L["own"]
                    else
                      edit_category_locale = BZ[val] or val -- falls es eine uebersetzung in bz gibt nimmmt er die sonst das enGB original 
                    end -- loescht alle alten werte wenn etwas neues angewaeht wurde
                    edit_name = nil
                    edit_id = nil
                    edit_enable = nil
                    edit_select = nil
                  end,
                  values = function() 
                    local val = {} -- sucht alle inis zusammen und packt diese in die table
                    for k,v in pairs(mod.gsv.blacklist) do
                      if val[v.category] == nil then
                        if v.category == "own" then
                          val[v.category] = L["own"]
                        else
                          val[v.category] = BZ[category] or v.category
                        end
                      end
                    end
                    return val
                  end,
                  },
                select_name = {
                  name = function () return edit_category_locale or " " end,
                  type = "select",
                  order = 2,
                  get = function() return edit_select or "" end, -- mag mich iwie nicht
                  set = function(_, val)
                    edit_id = val
                    edit_name = BB[mod.gsv.blacklist[val].name] or mod.gsv.blacklist[val].name
                    edit_enable = mod.gsv.blacklist[val].enable
                    edit_select = val
                  end,
                  values = function() 
                    local val = {}
                    if (edit_category ~= nil) then
                      for k,v in pairs(mod.gsv.blacklist) do
                        if (v.category == edit_category) then
                          local name = BB[v.name] or v.name
                          if v.enable then
                            val[k] = "|cFFFF0000"..name.."|r" -- rot
                          else
                            val[k] = "|cFF00FF00"..name.."|r" -- gruen
                          end
                        end
                      end
                    end
                    return val
                  end,
                  disabled = function()
                    return not (edit_category)
                  end
                  },
                n1 = {
                  type = "description",
                  name = "",
                  order = 3,
                  },
                mobid = {
                  name = L["mob id"],
                  type = "input",
                  order = 4,
                  get = function()
                    local out
                    if (edit_id ~= nil) then
                      out = tostring(edit_id)
                    else 
                      out = 0
                    end
                    return out 
                  end,
                  set = function(_, val)
                    edit_id = tonumber(val)
                  end,
                  multiline = false,
                  usage = "<"..L["the mob id is a number"]..">",
                  },
                mobname = {
                  name = L["mob name"],
                  type = "input",
                  order = 5,
                  get = function() return edit_name or "" end,
                  set = function(_, val)
                    edit_name = val
                  end,
                  multiline = false,
                  usage = "<"..L["simply the name"]..">",
                  },
                mobenable = {
                  name = L["enable"],
                  type = "toggle",
                  order = 6,
                  get = function() return edit_enable or false end,
                  set = function(_, val)
                    edit_enable = val
                  end,
                  },
                n2 = {
                  type = "description",
                  name = "",
                  order = 7,
                  },
                ok = {
                  name = L["ok"],
                  type = "execute",
                  order = 8,
                  desc = L["ok desc"],
                  func = function()
                    if edit_category == "own" then -- nur die eigenen soll man auch richtig aendern koennen
                      -- erstellt eine neue table die alle werte bis auf den editierten hat
                      local newtable = {}
                      for k,v in pairs(mod.gsv.blacklist) do
                        if (k ~= edit_id) then
                          newtable[k] = {
                            name = v.name, 
                            enable = v.enable,
                            category = v.category,
                          }
                        end
                      end
                      mod.gsv.blacklist = newtable
                      mod.gsv.blacklist[edit_id] = {
                        enable = edit_enable,
                        name = edit_name,
                        category = edit_category,
                      }
                    else
                      mod.gsv.blacklist[edit_id].enable = edit_enable
                    end
                  end,
                  disabled = function()
                    return not (edit_id and edit_name)
                  end
                  },
                delete = {
                  name = L["delete"],
                  type = "execute",
                  order = 9,
                  desc = L["delete desc"],
                  func = function()
                    -- erstellt eine neue table die alle werte bis auf den editierten hat
                    local newtable = {}
                    for k,v in pairs(mod.gsv.blacklist) do
                      if (k ~= edit_id) then 
                        newtable[k] = {
                          name = v.name, 
                          enable = v.enable,
                          category = v.category,
                        }
                      end
                    end
                    mod.gsv.blacklist = newtable
                    edit_id = nil
                    edit_name = nil
                    edit_enable = nil
                  end,
                  disabled = function()
                    return not (edit_category == "own")
                  end
                  }
                }
              }
            }
          }
  return blacklistoptions
  end
end

do
  local new_id, new_name, edit_id, edit_name, edit_enable, edit_select

  function AchScreenshotter2:getwhitelistoptions()
  local whitelistoptions = {
          name = L["whitelist"],
          type = "group",
          desc = L["whitelist desc"],
          order = 3,
          childGroups	= "tab",
          args = {
            new = {
              name = L["new"],
              type = "group",
              desc = L["new desc"],
              order = 1,
              args = {
                mobid = {
                  name = L["mob id"],
                  type = "input",
                  order = 1,
                  get = function()
                    local out
                    if (new_id ~= nil) then
                      out = tostring(new_id)
                    else 
                      out = 0
                    end
                    return out 
                  end,
                  set = function(_, val)
                    new_id = tonumber(val)
                  end,
                  multiline = false,
                  usage = "<"..L["the mob id is a number"]..">",
                  },
                mobname = {
                  name = L["mob name"],
                  type = "input",
                  order = 2,
                  get = function() return new_name or "" end,
                  set = function(_, val)
                    new_name = val
                  end,
                  multiline = false,
                  usage = "<"..L["simply the name"]..">",
                  },
                ok = {
                  name = L["ok"],
                  type = "execute",
                  order = 3,
                  desc = L["ok desc"],
                  func = function()
                    mod.gsv.whitelist[new_id] = {
                      enable = true,
                      name = new_name,
                    }
                    new_id = nil
                    new_name = nil
                  end,
                  disabled = function()
                    return not (new_id and new_name)
                  end
                  },
                },
              },
            edit = {
              name = L["edit"],
              type = "group",
              desc = L["edit desc"],
              order = 2,
              args = {
                select = {
                  name = L["whitelist"],
                  type = "select",
                  order = 1,
                  get = function() return edit_select or "" end,
                  set = function(_, val)
                    edit_id = val
                    edit_name = mod.gsv.whitelist[val].name
                    edit_enable = mod.gsv.whitelist[val].enable
                    edit_select = val
                  end,
                  values = function() 
                    local val = {}
                    for k,v in pairs(mod.gsv.whitelist) do
                      if v.enable then
                        val[k] = "|cFF00FF00"..v.name.."|r" -- gruen
                      else
                        val[k] = "|cFFFF0000"..v.name.."|r" -- rot
                      end
                    end
                    return val
                  end,
                  },
                n1 = {
                  type = "description",
                  name = "",
                  order = 2,
                  },
                mobid = {
                  name = L["mob id"],
                  type = "input",
                  order = 3,
                  get = function()
                    local out
                    if (edit_id ~= nil) then
                      out = tostring(edit_id)
                    else 
                      out = 0
                    end
                    return out 
                  end,
                  set = function(_, val)
                    edit_id = tonumber(val)
                  end,
                  multiline = false,
                  usage = "<"..L["the mob id is a number"]..">",
                  },
                mobname = {
                  name = L["mob name"],
                  type = "input",
                  order = 4,
                  get = function() return edit_name or "" end,
                  set = function(_, val)
                    edit_name = val
                  end,
                  multiline = false,
                  usage = "<"..L["simply the name"]..">",
                  },
                mobenable = {
                  name = L["enable"],
                  type = "toggle",
                  order = 5,
                  get = function() return edit_enable or false end,
                  set = function(_, val)
                    edit_enable = val
                  end,
                  },
                n2 = {
                  type = "description",
                  name = "",
                  order = 6,
                  },
                ok = {
                  name = L["ok"],
                  type = "execute",
                  order = 7,
                  desc = L["ok desc"],
                  func = function()
                    -- erstellt eine neue table die alle werte bis auf den editierten hat
                    local newtable = {}
                    for k,v in pairs(mod.gsv.whitelist) do
                      if (k ~= edit_id) then
                        newtable[k] = {
                          name = v.name, 
                          enable = v.enable
                        }
                      end
                    end
                    mod.gsv.whitelist = newtable
                    mod.gsv.whitelist[edit_id] = {
                      enable = edit_enable,
                      name = edit_name,
                    }
                  end,
                  disabled = function()
                    return not (edit_id and edit_name)
                  end
                  },
                delete = {
                  name = L["delete"],
                  type = "execute",
                  order = 8,
                  desc = L["delete desc"],
                  func = function()
                    -- erstellt eine neue table die alle werte bis auf den editierten hat
                    local newtable = {}
                    for k,v in pairs(mod.gsv.whitelist) do
                      if (k ~= edit_id) then 
                        newtable[k] = {
                          name = v.name, 
                          enable = v.enable
                        }
                      end
                    end
                    mod.gsv.whitelist = newtable
                    edit_id = nil
                    edit_name = nil
                    edit_enable = nil
                    edit_select = nil
                  end,
                  }
                }
              }
            }
          }
  return whitelistoptions
  end
end

function AchScreenshotter2:getblacklist()
  local blacklist = {
        [7797] = {
          enable = true,
          name = "Ruuzul",
          category = "Zul'Farrak",
          },
        [5711] = {  
          enable = true, 
          name = "Ogom the Wretched",
          category = "Temple of Atal'Hakkar",
          },
        [9042] = {
          enable = true,
          name = "Verek",
          category = "Blackrock Depths",
          },
        [17808] = {
          enable = true,
          name = "Anger'rel",
          category = "Blackrock Depths",
          },
        [9039] = {
          enable = true,
          name = "Doom'rel",
          category = "Blackrock Depths",
          },
        [9037] = {
          enable = true,
          name = "Gloom'rel",
          category = "Blackrock Depths",
          },
        [9034] = {
          enable = true,
          name = "Hate'rel",
          category = "Blackrock Depths",
          },
        [9038] = {
          enable = true, 
          name = "Seeth'rel",
          category = "Blackrock Depths",
          },
        [9036]   = { 
          enable = true, 
          name = "Vile'rel", 
          category = "Blackrock Depths",
          },
        [8929]   = { 
          enable = true, 
          name = "Princess Moira Bronzebeard", 
          category = "Blackrock Depths",
          },
        [14324]  = { 
          enable = true, 
          name = "Cho'Rush the Observer", 
          category = "Dire Maul",
          },
        [42178]	 = { 
          enable = true, 
          name = "Magmatron", 
          category = "Blackwing Descent",
          },
        [42179]	 = { 
          enable = true, 
          name = "Electron", 
          category = "Blackwing Descent",
          },
        [42180]	 = { 
          enable = true, 
          name = "Toxitron", 
          category = "Blackwing Descent",
          },
        [12557]  = { 
          enable = true, 
          name = "Grethok the Controller", 
          category = "Blackwing Lair",
          },
        [15511]  = { 
          enable = true, 
          name = "Lord Kri", 
          category = "Temple of Ahn'Qiraj",
          },
        [15543]  = { 
          enable = true, 
          name = "Princess Yauj", 
          category = "Temple of Ahn'Qiraj",
          },
        [15544]  = { 
          enable = true, 
          name = "Vem", 
          category = "Temple of Ahn'Qiraj",
          },
        [15589]  = { 
          enable = true, 
          name = "Eye of C'Thun", 
          category = "Temple of Ahn'Qiraj",
          },
        [16065]  = { 
          enable = true, 
          name = "Lady Blaumeux", 
          category = "Naxxramas",
          },
        [16064]  = { 
          enable = true, 
          name = "Thane Korth'azz", 
          category = "Naxxramas",
          },
        [16062]  = { 
          enable = true, 
          name = "Highlord Mograine", 
          category = "Naxxramas",
          },
        [16063]  = { 
          enable = true, 
          name = "Sir Zeliek", 
          category = "Naxxramas",
          },
        [30549]  = { 
          enable = true, 
          name = "Baron Rivendare", 
          category = "Naxxramas",
          },
        [16803]  = { 
          enable = true, 
          name = "Death Knight Understudy", 
          category = "Naxxramas",
          },
        [15930]  = { 
          enable = true, 
          name = "Feugen", 
          category = "Naxxramas",
          },
        [15929]  = { 
          enable = true, 
          name = "Stalagg", 
          category = "Naxxramas",
          },
        [17536]  = { 
          enable = true, 
          name = "Nazan", 
          category = "Hellfire Ramparts",
          },
        [17827]  = { 
          enable = true, 
          name = "Claw", 
          category = "The Underbog",
          },
        [16151]  = { 
          enable = true, 
          name = "Midnight", 
          category = "Karazhan",
          },
        [17229]  = { 
          enable = true, 
          name = "Kil'rek", 
          category = "Karazhan",
          },
        [17535]  = { 
          enable = true, 
          name = "Dorothee", 
          category = "Karazhan",
          },
        [17546]  = { 
          enable = true, 
          name = "Roar", 
          category = "Karazhan",
          },
        [17543]  = { 
          enable = true, 
          name = "Strawman", 
          category = "Karazhan",
          },
        [17547]  = { 
          enable = true, 
          name = "Tinhead", 
          category = "Karazhan",
          },
        [17548]  = { 
          enable = true, 
          name = "Tito", 
          category = "Karazhan",
          },
        [17533]  = { 
          enable = true, 
          name = "Romulo", 
          category = "Karazhan",
          },
        [17534]  = { 
          enable = true, 
          name = "Julianne", 
          category = "Karazhan",
          },
        [18835]  = { 
          enable = true, 
          name = "Kiggler the Crazed", 
          category = "Gruul's Lair",
          },
        [18836]  = { 
          enable = true, 
          name = "Blindeye the Seer", 
          category = "Gruul's Lair",
          },
        [18834]  = { 
          enable = true, 
          name = "Olm the Summoner", 
          category = "Gruul's Lair",
          },
        [18832]  = { 
          enable = true, 
          name = "Krosh Firehand", 
          category = "Gruul's Lair",
          },
        [39428]  = { 
          enable = true, 
          name = "Earthrager Ptah", 
          category = "Halls of Origination",
          },
        [21875]  = { 
          enable = true, 
          name = "Shadow of Leotheras", 
          category = "Serpentshrine Cavern",
          },
        [20064]  = { 
          enable = true, 
          name = "Thaladred the Darkener", 
          category = "The Eye",
          },
        [20060]  = { 
          enable = true, 
          name = "Lord Sanguinar", 
          category = "The Eye",
          },
        [20062]  = { 
          enable = true, 
          name = "Grand Astromancer Capernian", 
          category = "The Eye",
          },
        [20063]  = { 
          enable = true, 
          name = "Master Engineer Telonicus", 
          category = "The Eye",
          },
        [21270]  = { 
          enable = true, 
          name = "Cosmic Infuser", 
          category = "The Eye",
          },
        [21269]  = { 
          enable = true, 
          name = "Devastation", 
          category = "The Eye",
          },
        [21271]  = { 
          enable = true, 
          name = "Infinity Blades", 
          category = "The Eye",
          },
        [21268]  = { 
          enable = true, 
          name = "Netherstrand Longbow", 
          category = "The Eye",
          },
        [21273]  = { 
          enable = true, 
          name = "Phaseshift Bulwark", 
          category = "The Eye",
          },
        [21274]  = { 
          enable = true, 
          name = "Staff of Disintegration", 
          category = "The Eye",
          },
        [21272]  = { 
          enable = true, 
          name = "Warp Slicer", 
          category = "The Eye",
          },
        [23419]  = { 
          enable = true, 
          name = "Essence of Desire", 
          category = "Black Temple",
          },
        [23418]  = { 
          enable = true, 
          name = "Essence of Suffering", 
          category = "Black Temple",
          },
        [22950]  = { 
          enable = true, 
          name = "High Nethermancer Zerevor", 
          category = "Black Temple",
          },
        [22951]  = { 
          enable = true, 
          name = "Lady Malande", 
          category = "Black Temple",
          },
        [22952]  = { 
          enable = true, 
          name = "Veras Darkshadow", 
          category = "Black Temple",
          },
        [25165]  = { 
          enable = true, 
          name = "Lady Sacrolash", 
          category = "Sunwell Plateau",
          },
        [25741]  = { 
          enable = true, 
          name = "M'uru", 
          category = "Sunwell Plateau",
          },
        [24892]  = { 
          enable = true, 
          name = "Sathrovarr the Corruptor", 
          category = "Sunwell Plateau",
          },
        [23954]  = { 
          enable = true, 
          name = "Ingvar the Plunderer", 
          category = "Utgarde Keep",
          },
        [24201]  = { 
          enable = true, 
          name = "Dalronn the Controller", 
          category = "Utgarde Keep",
          },
        [26832]  = { 
          enable = true, 
          name = "Grand Magus Telestra", 
          category = "The Nexus",
          },
        [26928]  = { 
          enable = true, 
          name = "Grand Magus Telestra", 
          category = "The Nexus",
          },
        [26929]  = { 
          enable = true, 
          name = "Grand Magus Telestra", 
          category = "The Nexus",
          },
        [26930]  = { 
          enable = true, 
          name = "Grand Magus Telestra", 
          category = "The Nexus",
          },
        [35617]  = { 
          enable = true, 
          name = "Deathstalker Visceri", 
          category = "Trial of the Champion",
          },
        [35569]  = { 
          enable = true, 
          name = "Eressea Dawnsinger", 
          category = "Trial of the Champion",
          },
        [35572]  = { 
          enable = true, 
          name = "Mokra the Skullcrusher", 
          category = "Trial of the Champion",
          },
        [35571]  = {
          enable = true, 
          name = "Runok Wildmane", 
          category = "Trial of the Champion",
          },
        [35570]  = {
          enable = true, 
          name = "Zul'tore", 
          category = "Trial of the Champion",
          },
        [34702]  = {
          enable = true, 
          name = "Ambrose Boltspark", 
          category = "Trial of the Champion",
          },
        [34701]  = {
          enable = true, 
          name = "Colosos", 
          category = "Trial of the Champion",
          },
        [34705]  = {
          enable = true, 
          name = "Marshal Jacob Alerius", 
          category = "Trial of the Champion",
          },
        [34657]  = {
          enable = true, 
          name = "Jaelyne Evensong", 
          category = "Trial of the Champion",
          },
        [34703]  = {
          enable = true, 
          name = "Lana Stouthammer", 
          category = "Trial of the Champion",
          },
        [36476]  = {
          enable = true, 
          name = "Ick", 
          category = "Pit of Saron",
          },
        [30451]  = {
          enable = true, 
          name = "Shadron", 
          category = "Obsidian Sanctum",
          },
        [30452]  = {
          enable = true, 
          name = "Tenebron", 
          category = "Obsidian Sanctum",
          },
        [30449]  = {
          enable = true, 
          name = "Vesperon", 
          category = "Obsidian Sanctum",
          },
        [31125]  = {
          enable = true, 
          name = "Archavon the Stone Watcher", 
          category = "Vault of Archavon",
          },
        [33993]  = {
          enable = true, 
          name = "Emalon the Storm Watcher", 
          category = "Vault of Archavon",
          },
        [35013]  = {
          enable = true, 
          name = "Koralon the Flamewatcher", 
          category = "Vault of Archavon",
          },
        [32867]  = {
          enable = true, 
          name = "Steelbreaker", 
          category = "Ulduar",
          },
        [32927]  = {
          enable = true, 
          name = "Runemaster Molgeim", 
          category = "Ulduar",
          },
        [32857]  = {
          enable = true, 
          name = "Stormcaller Brundir", 
          category = "Ulduar",
          },
        [34035]  = {
          enable = true, 
          name = "Feral Defender", 
          category = "Ulduar",
          },
        [32933]  = {
          enable = true, 
          name = "Left Arm", 
          category = "Ulduar",
          },
        [32934]  = {
          enable = true, 
          name = "Right Arm", 
          category = "Ulduar",
          },
        [33524]  = {
          enable = true, 
          name = "Saronite Animus", 
          category = "Ulduar",
          },
        [33890]  = {
          enable = true, 
          name = "Brain of Yogg-Saron", 
          category = "Ulduar",
          },
        [32915]  = {
          enable = true, 
          name = "Elder Brightleaf", 
          category = "Ulduar",
          },
        [32913]  = {
          enable = true, 
          name = "Elder Ironbranch", 
          category = "Ulduar",
          },
        [32914]  = {
          enable = true, 
          name = "Elder Stonebark", 
          category = "Ulduar",
          },
        [32882]  = {
          enable = true, 
          name = "Jormungar Behemoth", 
          category = "Ulduar",
          },
        [33432]  = {
          enable = true, 
          name = "Leviathan Mk II", 
          category = "Ulduar",
          },
        [34014]  = {
          enable = true, 
          name = "Sanctum Sentry", 
          category = "Ulduar",
          },
        [33136]  = {
          enable = true, 
          name = "Guardian of Yogg-Saron", 
          category = "Ulduar",
          },
        [33329]  = {
          enable = true, 
          name = "Heart of the Deconstructor", 
          category = "Ulduar",
          },
        [33651]  = {
          enable = true, 
          name = "VX-001", 
          category = "Ulduar",
          },
        [34796]  = {
          enable = true, 
          name = "Gormok", 
          category = "Trial of the Crusader",
          },
        [35144]  = {
          enable = true, 
          name = "Acidmaw", 
          category = "Trial of the Crusader",
          },
        [34799]  = {
          enable = true, 
          name = "Dreadscale", 
          category = "Trial of the Crusader",
          },
        [34461]  = {
          enable = true, 
          name = "Tyrius Duskblade", 
          category = "Trial of the Crusader",
          },
        [34460]  = {
          enable = true, 
          name = "Kavina Grovesong", 
          category = "Trial of the Crusader",
          },
        [34469]  = {
          enable = true, 
          name = "Melador Valestrider", 
          category = "Trial of the Crusader",
          },
        [34467]  = {
          enable = true, 
          name = "Alyssia Moonstalker", 
          category = "Trial of the Crusader",
          },
        [34468]  = {
          enable = true, 
          name = "Noozle Whizzlestick", 
          category = "Trial of the Crusader",
          },
        [34465]  = {
          enable = true, 
          name = "Velanaa", 
          category = "Trial of the Crusader",
          },
        [34471]  = {
          enable = true, 
          name = "Baelnor Lightbearer", 
          category = "Trial of the Crusader",
          },
        [34466]  = {
          enable = true, 
          name = "Anthar Forgemender", 
          category = "Trial of the Crusader",
          },
        [34473]  = {
          enable = true, 
          name = "Brienna Nightfell", 
          category = "Trial of the Crusader",
          },
        [34472]  = {
          enable = true, 
          name = "Irieth Shadowstep", 
          category = "Trial of the Crusader",
          },
        [34470]  = {
          enable = true, 
          name = "Saamul", 
          category = "Trial of the Crusader",
          },
        [34463]  = {
          enable = true, 
          name = "Shaabad", 
          category = "Trial of the Crusader",
          },
        [34474]  = {
          enable = true, 
          name = "Serissa Grimdabbler", 
          category = "Trial of the Crusader",
          },
        [34475]  = {
          enable = true, 
          name = "Shocuul", 
          category = "Trial of the Crusader",
          },
        [34458]  = {
          enable = true, 
          name = "Gorgrim Shadowcleave", 
          category = "Trial of the Crusader",
          },
        [34451]  = {
          enable = true, 
          name = "Birana Stormhoof", 
          category = "Trial of the Crusader",
          },
        [34459]  = {
          enable = true, 
          name = "Erin Misthoof", 
          category = "Trial of the Crusader",
          },
        [34448]  = {
          enable = true, 
          name = "Ruj'kah", 
          category = "Trial of the Crusader",
          },
        [34449]  = {
          enable = true, 
          name = "Ginselle Blightslinger", 
          category = "Trial of the Crusader",
          },
        [34445]  = {
          enable = true, 
          name = "Liandra Suncaller", 
          category = "Trial of the Crusader",
          },
        [34456]  = {
          enable = true, 
          name = "Malithas Brightblade", 
          category = "Trial of the Crusader",
          },
        [34447]  = {
          enable = true, 
          name = "Caiphus the Stern", 
          category = "Trial of the Crusader",
          },
        [34441]  = {
          enable = true, 
          name = "Vivienne Blackwhisper", 
          category = "Trial of the Crusader",
          },
        [34454]  = {
          enable = true, 
          name = "Maz'dinah", 
          category = "Trial of the Crusader",
          },
        [34444]  = {
          enable = true, 
          name = "Thrakgar", 
          category = "Trial of the Crusader",
          },
        [34455]  = {
          enable = true, 
          name = "Broln Stouthorn", 
          category = "Trial of the Crusader",
          },
        [34450]  = {
          enable = true, 
          name = "Harkzog", 
          category = "Trial of the Crusader",
          },
        [34453]  = {
          enable = true, 
          name = "Narrhok Steelbreaker", 
          category = "Trial of the Crusader",
          },
        [35610]  = {
          enable = true, 
          name = "Cat", 
          category = "Trial of the Crusader",
          },
        [35465]  = {
          enable = true, 
          name = "Zhaagrym", 
          category = "Trial of the Crusader",
          },
        [34497]  = {
          enable = true, 
          name = "Fjola Lightbane", 
          category = "Trial of the Crusader",
          },
        [37970]  = {
          enable = true, 
          name = "Prince Valanar", 
          category = "Icecrown Citadel",
          },
        [37973]  = {
          enable = true, 
          name = "Prince Taldaram", 
          category = "Icecrown Citadel",
          },
        [37868]  = {
          enable = true, 
          name = "Risen Archmage", 
          category = "Icecrown Citadel",
          },
        [36791]  = {
          enable = true, 
          name = "Blazing Skeleton", 
          category = "Icecrown Citadel",
          },
        [37934]  = {
          enable = true, 
          name = "Blistering Zombie", 
          category = "Icecrown Citadel",
          },
        [37886]  = {
          enable = true, 
          name = "Gluttonous Abomination ", 
          category = "Icecrown Citadel",
          },
        [37985]  = {
          enable = true, 
          name = "Dream Cloud", 
          category = "Icecrown Citadel",
          },
        [37217]  = {
          enable = true, 
          name = "Precious", 
          category = "Icecrown Citadel",
          },
        [37025]  = {
          enable = true, 
          name = "Stinki", 
          category = "Icecrown Citadel",
          },
        [36661]  = {
          enable = true, 
          name = "Rimefang", 
          category = "Icecrown Citadel",
          },
        [39746]  = {
          enable = true, 
          name = "Zarithrian", 
          category = "Ruby Sanctum",
          },
        [39747]  = {
          enable = true, 
          name = "Saviana", 
          category = "Ruby Sanctum",
          },
        [39751]  = {
          enable = true, 
          name = "Baltharus", 
          category = "Ruby Sanctum",
          },
        [39899]  = {
          enable = true, 
          name = "Baltharus", 
          category = "Ruby Sanctum",
          },
        [52157]  = {
          enable = true, 
          name = "Ohgan", 
          category = "Zul'Gurub",
          },
        }
return blacklist
end
