local debug = false
--[===[@alpha@
debug = true
--@end-alpha@]===]
local L = LibStub("AceLocale-3.0"):GetLocale("AchScreenshotter2", not debug)

local mod = AchScreenshotter2
local addonname = "AchScreenShotter2"

-- (c) shPreformance
-->tooltip anchor
local function GetTipAnchor(frame)
  local x,y = frame:GetCenter()
  if not x or not y then return "TOPLEFT", "BOTTOMLEFT" end
  local hhalf = (x > UIParent:GetWidth()*2/3) and "RIGHT" or (x < UIParent:GetWidth()/3) and "LEFT" or ""
  local vhalf = (y > UIParent:GetHeight()/2) and "TOP" or "BOTTOM"
  return vhalf..hhalf, frame, (vhalf == "TOP" and "BOTTOM" or "TOP")..hhalf
end

function AchScreenshotter2:LoadDataBrokerPlugin()
  LibStub:GetLibrary('LibDataBroker-1.1'):NewDataObject(addonname, {
    type = "launcher",
    icon = [[Interface\Icons\Ability_TownWatch]],
    text = addonname,

    OnClick = function(_, button)
      if button == "RightButton" then
        InterfaceOptionsFrame_OpenToCategory(addonname)
      elseif button == "LeftButton" then
        if IsShiftKeyDown() then
          if mod.sv.enable then 
            mod.sv.enable = false
            mod:RefreshConfig()
          else
            mod.sv.enable = true
            mod:RefreshConfig()
          end
        elseif IsControlKeyDown() then
          mod:take_screenshot("user", true, 0)
        else
          mod:take_screenshot("user", false, 0)
        end
      end
    end,

    OnEnter = function(self)
      GameTooltip:SetOwner(self, "ANCHOR_NONE")
      GameTooltip:SetPoint(GetTipAnchor(self))
      GameTooltip:ClearLines()

      local version = GetAddOnMetadata(addonname, "X-Curse-Packaged-Version") or ""

      GameTooltip:AddLine(addonname.." "..version)
      GameTooltip:AddLine("|cFF00FF00"..L["right click"] .."|r ".. L["right click desc"])
      GameTooltip:AddLine("|cFF00FF00"..L["left click"] .."|r ".. L["left click desc"])
      GameTooltip:AddLine("|cFF00FF00"..L["left click shift"] .."|r ".. L["left click shift desc"])
      GameTooltip:AddLine("|cFF00FF00"..L["left click ctrl"] .."|r ".. L["left click ctrl desc"])

      if not mod.sv.enable then
        GameTooltip:AddLine("|cFFFF0000"..L["disabled"].."|r")
      end

      if mod.sv.statistic.enable and mod.sv.enable then
        if mod.sv.achievement.enable then
          GameTooltip:AddDoubleLine("|cFF00FF00"..L["achievement statistic desc:"].."|r", mod.sv.statistic.achievement)
        end
        if mod.sv.levelup.enable then
          GameTooltip:AddDoubleLine("|cFF00FF00"..L["levelup statistic desc:"].."|r", mod.sv.statistic.levelup)
        end
        if mod.sv.reputation.enable then
          GameTooltip:AddDoubleLine("|cFF00FF00"..L["reputation statistic desc:"].."|r", mod.sv.statistic.reputation)
        end
        if mod.sv.bg.enable then
          GameTooltip:AddDoubleLine("|cFF00FF00"..L["battleground statistic desc:"].."|r", mod.sv.statistic.battleground)
        end
        if mod.sv.dungeon.enable then
          GameTooltip:AddDoubleLine("|cFF00FF00"..L["dungeon statistic desc:"].."|r", mod.sv.statistic.dungeon)
        end
        if mod.sv.boss.enable then
          GameTooltip:AddDoubleLine("|cFF00FF00"..L["boss statistic desc:"].."|r", mod.sv.statistic.boss)
        end
        GameTooltip:AddDoubleLine("|cFF00FF00"..L["user statistic desc:"].."|r", mod.sv.statistic.user)
        GameTooltip:AddDoubleLine("|cFFFF0000"..L["fails statistic desc:"].."|r", mod.sv.statistic.fails)
      end

      GameTooltip:Show()
    end,

    OnLeave = function()
      GameTooltip:SetClampedToScreen(true)
      GameTooltip:Hide()
    end,
    })
end